package edu.ucla.iBeaconNav;

public class CMD {
	/* Task Commands */
	static enum Command {
		REGISTER,
		CONNECT,
		DISCONNECT,
		RSTHEAD,
		RSTDST,
	}

	/* Responses Commands */
	static enum Response {
		REGISTER,
		NOTIFY,
		SHOWDATA,
	}

	/* Data Source IDs */
	static enum Source {
		GPS,
		INERTIAL,
		IBEACON,
	}

	/* Show Data Commands */
	static enum Data {
		ACC,      // x,      y,       z
		MAG,      // x,      y,       z
		GYR,      // roll,   pitch,   yaw  (delta radians?)
		GYR1HZ,   // roll,   pitch,   yaw  (delta radians?)
		ORIENT,   // roll,   pitch,   yaw  (???
		WRDACC,   // x,      y,       z    (world frame)
		WRDGYR,   // roll,   pitch,   yaw  (worldf rame?)
		STPCNT,   // count,  gravity
		POSITION, // cur x,  cur y
		ROTATION, // roll,   pitch,   yaw  (degrees)
		HEADING,  // heading
		STABLE,   // stable                (true/false)
		BEACON,   // lat,    lon,     dist
	}
}
